##FirmataWithDeviceFeature

###A fork of Configurable Firmata with the addition of the DeviceFirmata feature, enabling the use of device driver modules as defined by LuniLib.

####Summary

ConfigurableFirmata is a Firmata implementation that splits the various capabilities of Firmata into separate
classes that can be included or excluded when an Arduino program is compiled and linked in order to tailor the
code to the needs of the application and (hopefully) save memory.  This FirmataWithDeviceFeature is a fork of
ConfigurableFirmata and includes an additional feature that recognizes and manages DEVICE\_QUERY and DEVICE\_RESPONSE
Sysex messages.

The stable release repositories for the LuniLib related packages are available on github.com from user finson-release.

####Release v0.9, July 2016

This library is one of several concurrent v0.9 releases.

- The Arduino library LuniLib (Arduino Device Driver framework and a few example drivers)
- FirmataWithDeviceFeature, a fork of ConfigurableFirmata that includes the DeviceFirmata pull request
- LuniJS (Javascript NodeJS client package)

Changes to FirmataWithDeviceFeature for v0.9 include:

1.  Minor changes to facilitate use of the Arduino library manager: version number, library.properties
2.  Additions and updates to the documentation: release notes.

Dependencies

- LuniLib by Doug Johnson at https://github.com/finson-release/luni
- base64 by Adam Rudd at https://github.com/adamvr/arduino-base64

####Release v0.8, May 2016

First release for beta testing.

This library is part of several concurrent v0.8 releases:

- This Arduino library LuniLib
- Update to Configurable Firmata (Arduino Firmata host connection to remote clients)
- LuniJS (Javascript NodeJS client package)
- LuniFive (Javascript Johnny-Five client controller examples)  [Update.  No, didn't happen, see LuniJS for a Johnny-Five example.]

There are initially three ways to use this library.

1.  Standalone LuniLib.  All code is on the Arduino and there is no external control of the various device drivers.  There are examples included in the library. Only the LuniLib itself is needed for this configuration.
2.  NodeJS and LuniLib.  The device driver library (and a device driver or two), along with an updated Configurable Firmata are on the Arduino, and NodeJS is running on a client.  Required packages are Arduino LuniLib, updated Configurable Firmata, and lunijs, an addon to firmata.js.
3.  Johnny-Five and LuniLib.The device driver library (and a device driver or two), along with an updated Configurable Firmata are on the Arduino, and Johnny-Five is running on a client.  All four packages listed above are needed in this configuration.
